﻿using IRaCIS.Application.Contracts;
using IRaCIS.Core.Application.ViewModel;
using IRaCIS.Core.Domain.Share;

namespace IRaCIS.Core.Application.Service
{
    public interface IUserService
    {
        Task<IResponseOutput<UserAddedReturnDTO>> AddUser(UserCommand userAddModel);
        //Task<IResponseOutput> DeleteUser(Guid userId);
        //Task<UserDetailDTO> GetUser(Guid id);
        Task<PageOutput<UserListDTO>> GetUserList(UserListQueryDTO param);
        Task<IResponseOutput<LoginReturnDTO>> Login(string userName, string password);
        Task<IResponseOutput> VerifyMFACodeAsync(string Code);

        Task<IResponseOutput> SendMFAEmail(SendMfaCommand sendMfa);
        Task<UserBasicInfo> GetUserBasicInfo(Guid userId, string pwd);
        Task<IResponseOutput> ModifyPassword(EditPasswordCommand editPwModel);
        Task<IResponseOutput> ResetPassword(Guid userId);

        Task<IResponseOutput> UpdateUser(UserCommand model);
        //Task<IResponseOutput> UpdateUserState(Guid userId, UserStateEnum state);

        //Task<IResponseOutput> SendVerificationCode(string emailOrPhone, VerifyType verificationType, bool isReviewer = false);
        //Task<IResponseOutput> SetNewPassword(ResetPasswordCommand resetPwdModel);
    }
}