namespace IRaCIS.Core.Domain.Models;

[Comment("受试者访视 - 既往其他治疗史")]
[Table("PreviousOther")]
public class PreviousOther : BaseAddAuditEntity
{
    #region 导航属性

    [JsonIgnore]
    public SubjectVisit SubjectVisit { get; set; }

    [JsonIgnore]
    [ForeignKey("ClinicalDataTrialSetId")]

    public ClinicalDataTrialSet ClinicalDataTrialSet { get; set; }
    #endregion

    public DateTime? StartTime { get; set; }
    public DateTime? EndTime { get; set; }
    public bool IsPD { get; set; }

    public Guid SubjectVisitId { get; set; }
    public bool IsSubjectLevel { get; set; }
    public string Path { get; set; } = String.Empty;
    public string FileName { get; set; } = String.Empty;
    public string TreatmentType { get; set; } = String.Empty;

    [Comment("临床数据类型Id")]
    
    public Guid ClinicalDataTrialSetId { get; set; }

}

