﻿using IRaCIS.Core.Domain.Share;

namespace IRaCIS.Core.Domain.Models;

[Comment("医生 - 入组项目中间记录表")]
[Table("Enroll")]
public partial class Enroll : BaseFullAuditEntity
{
    #region 导航属性
    [JsonIgnore]
    [ForeignKey("TrialId")]
    public virtual Trial Trial { get; set; }
    [JsonIgnore]
    public virtual Doctor Doctor { get; set; }
    [JsonIgnore]
    public UserRole DoctorUser { get; set; }
    [JsonIgnore]
    public List<EnrollReadingCategory> EnrollReadingCategoryList { get; set; }

    [JsonIgnore]
    public List<EnrollReadingCriterion> EnrollReadingCriteriaList { get; set; }
    #endregion
    public Guid DoctorId { get; set; }
    public Guid TrialId { get; set; }
    public Guid? AttachmentId { get; set; }
    public EnrollStatus EnrollStatus { get; set; }

    public decimal? AdjustmentMultiple { get; set; }
    public DateTime? EnrollTime { get; set; }
    public DateTime? OutEnrollTime { get; set; }

    public string Memo { get; set; } = string.Empty;

    public int ReviewerReadingType { get; set; } = 0;

    public int? Training { get; set; }

    public int? RefresherTraining { get; set; }

    public int? Timepoint { get; set; }

    public int? Timepoint48H { get; set; }

    public int? Timepoint24H { get; set; }

    public int? Adjudication { get; set; }

    public int? Adjudication48H { get; set; }

    public int? Adjudication24H { get; set; }

    public int? Global { get; set; }

    public int? Downtime { get; set; }


    [Comment("生成账号  加入到项目中后 赋值")]
    public Guid? DoctorUserId { get; set; }
}
