﻿using Microsoft.EntityFrameworkCore.Migrations;

#nullable disable

namespace IRaCIS.Core.Infra.EFCore.Migrations
{
    /// <inheritdoc />
    public partial class trialExperience : Migration
    {
        /// <inheritdoc />
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.AddColumn<bool>(
                name: "IsAddTrialExperienceToTrial",
                table: "Doctor",
                type: "bit",
                nullable: false,
                defaultValue: false);

            migrationBuilder.CreateIndex(
                name: "IX_PreviousSurgery_ClinicalDataTrialSetId",
                table: "PreviousSurgery",
                column: "ClinicalDataTrialSetId");

            migrationBuilder.CreateIndex(
                name: "IX_PreviousOther_ClinicalDataTrialSetId",
                table: "PreviousOther",
                column: "ClinicalDataTrialSetId");

            migrationBuilder.CreateIndex(
                name: "IX_PreviousHistory_ClinicalDataTrialSetId",
                table: "PreviousHistory",
                column: "ClinicalDataTrialSetId");

            migrationBuilder.AddForeignKey(
                name: "FK_PreviousHistory_ClinicalDataTrialSet_ClinicalDataTrialSetId",
                table: "PreviousHistory",
                column: "ClinicalDataTrialSetId",
                principalTable: "ClinicalDataTrialSet",
                principalColumn: "Id",
                onDelete: ReferentialAction.Cascade);

            migrationBuilder.AddForeignKey(
                name: "FK_PreviousOther_ClinicalDataTrialSet_ClinicalDataTrialSetId",
                table: "PreviousOther",
                column: "ClinicalDataTrialSetId",
                principalTable: "ClinicalDataTrialSet",
                principalColumn: "Id",
                onDelete: ReferentialAction.Cascade);

            migrationBuilder.AddForeignKey(
                name: "FK_PreviousSurgery_ClinicalDataTrialSet_ClinicalDataTrialSetId",
                table: "PreviousSurgery",
                column: "ClinicalDataTrialSetId",
                principalTable: "ClinicalDataTrialSet",
                principalColumn: "Id",
                onDelete: ReferentialAction.Cascade);
        }

        /// <inheritdoc />
        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_PreviousHistory_ClinicalDataTrialSet_ClinicalDataTrialSetId",
                table: "PreviousHistory");

            migrationBuilder.DropForeignKey(
                name: "FK_PreviousOther_ClinicalDataTrialSet_ClinicalDataTrialSetId",
                table: "PreviousOther");

            migrationBuilder.DropForeignKey(
                name: "FK_PreviousSurgery_ClinicalDataTrialSet_ClinicalDataTrialSetId",
                table: "PreviousSurgery");

            migrationBuilder.DropIndex(
                name: "IX_PreviousSurgery_ClinicalDataTrialSetId",
                table: "PreviousSurgery");

            migrationBuilder.DropIndex(
                name: "IX_PreviousOther_ClinicalDataTrialSetId",
                table: "PreviousOther");

            migrationBuilder.DropIndex(
                name: "IX_PreviousHistory_ClinicalDataTrialSetId",
                table: "PreviousHistory");

            migrationBuilder.DropColumn(
                name: "IsAddTrialExperienceToTrial",
                table: "Doctor");
        }
    }
}
