﻿using Microsoft.EntityFrameworkCore.Migrations;

#nullable disable

namespace IRaCIS.Core.Infra.EFCore.Migrations
{
    /// <inheritdoc />
    public partial class DoctorHospital : Migration
    {
        /// <inheritdoc />
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_SCPInstance_SCPStudy_StudyId",
                table: "SCPInstance");

            migrationBuilder.DropForeignKey(
                name: "FK_TaskInstance_TaskStudy_StudyId",
                table: "TaskInstance");

            migrationBuilder.DropColumn(
                name: "IsConfirm",
                table: "Hospital");

            migrationBuilder.AddColumn<string>(
                name: "City",
                table: "Doctor",
                type: "nvarchar(400)",
                maxLength: 400,
                nullable: false,
                defaultValue: "");

            migrationBuilder.AddColumn<string>(
                name: "CityCN",
                table: "Doctor",
                type: "nvarchar(400)",
                maxLength: 400,
                nullable: false,
                defaultValue: "");

            migrationBuilder.AddColumn<string>(
                name: "HospitalCN",
                table: "Doctor",
                type: "nvarchar(400)",
                maxLength: 400,
                nullable: false,
                defaultValue: "");

            migrationBuilder.AddColumn<string>(
                name: "HospitalEn",
                table: "Doctor",
                type: "nvarchar(400)",
                maxLength: 400,
                nullable: false,
                defaultValue: "");

            migrationBuilder.AddColumn<string>(
                name: "University",
                table: "Doctor",
                type: "nvarchar(400)",
                maxLength: 400,
                nullable: false,
                defaultValue: "");

            migrationBuilder.AddColumn<string>(
                name: "UniversityCN",
                table: "Doctor",
                type: "nvarchar(400)",
                maxLength: 400,
                nullable: false,
                defaultValue: "");

            migrationBuilder.AddForeignKey(
                name: "FK_SCPInstance_SCPStudy_StudyId",
                table: "SCPInstance",
                column: "StudyId",
                principalTable: "SCPStudy",
                principalColumn: "Id",
                onDelete: ReferentialAction.Cascade);

            migrationBuilder.AddForeignKey(
                name: "FK_TaskInstance_TaskStudy_StudyId",
                table: "TaskInstance",
                column: "StudyId",
                principalTable: "TaskStudy",
                principalColumn: "Id",
                onDelete: ReferentialAction.Cascade);
        }

        /// <inheritdoc />
        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_SCPInstance_SCPStudy_StudyId",
                table: "SCPInstance");

            migrationBuilder.DropForeignKey(
                name: "FK_TaskInstance_TaskStudy_StudyId",
                table: "TaskInstance");

            migrationBuilder.DropColumn(
                name: "City",
                table: "Doctor");

            migrationBuilder.DropColumn(
                name: "CityCN",
                table: "Doctor");

            migrationBuilder.DropColumn(
                name: "HospitalCN",
                table: "Doctor");

            migrationBuilder.DropColumn(
                name: "HospitalEn",
                table: "Doctor");

            migrationBuilder.DropColumn(
                name: "University",
                table: "Doctor");

            migrationBuilder.DropColumn(
                name: "UniversityCN",
                table: "Doctor");

            migrationBuilder.AddColumn<bool>(
                name: "IsConfirm",
                table: "Hospital",
                type: "bit",
                nullable: false,
                defaultValue: false);

            migrationBuilder.AddForeignKey(
                name: "FK_SCPInstance_SCPStudy_StudyId",
                table: "SCPInstance",
                column: "StudyId",
                principalTable: "SCPStudy",
                principalColumn: "SeqId",
                onDelete: ReferentialAction.Cascade);

            migrationBuilder.AddForeignKey(
                name: "FK_TaskInstance_TaskStudy_StudyId",
                table: "TaskInstance",
                column: "StudyId",
                principalTable: "TaskStudy",
                principalColumn: "SeqId",
                onDelete: ReferentialAction.Cascade);
        }
    }
}
