﻿using System;
using Microsoft.EntityFrameworkCore.Migrations;

#nullable disable

namespace IRaCIS.Core.Infra.EFCore.Migrations
{
    /// <inheritdoc />
    public partial class TrialIdentityUser : Migration
    {
        /// <inheritdoc />
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.AlterTable(
                name: "TrialUser",
                comment: "项目用户角色表",
                oldComment: "运维人员与项目关联关系表 - 实体");

            migrationBuilder.CreateTable(
                name: "TrialIdentityUser",
                columns: table => new
                {
                    Id = table.Column<Guid>(type: "uniqueidentifier", nullable: false),
                    TrialId = table.Column<Guid>(type: "uniqueidentifier", nullable: false),
                    IdentityUserId = table.Column<Guid>(type: "uniqueidentifier", nullable: false),
                    RemoveTime = table.Column<DateTime>(type: "datetime2", nullable: true),
                    JoinTime = table.Column<DateTime>(type: "datetime2", nullable: true),
                    DeleteUserId = table.Column<Guid>(type: "uniqueidentifier", nullable: true),
                    IsDeleted = table.Column<bool>(type: "bit", nullable: false),
                    DeletedTime = table.Column<DateTime>(type: "datetime2", nullable: true),
                    CreateUserId = table.Column<Guid>(type: "uniqueidentifier", nullable: false),
                    CreateTime = table.Column<DateTime>(type: "datetime2", nullable: false),
                    UpdateUserId = table.Column<Guid>(type: "uniqueidentifier", nullable: false),
                    UpdateTime = table.Column<DateTime>(type: "datetime2", nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_TrialIdentityUser", x => x.Id);
                    table.ForeignKey(
                        name: "FK_TrialIdentityUser_IdentityUser_IdentityUserId",
                        column: x => x.IdentityUserId,
                        principalTable: "IdentityUser",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_TrialIdentityUser_Trial_TrialId",
                        column: x => x.TrialId,
                        principalTable: "Trial",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_TrialIdentityUser_User_CreateUserId",
                        column: x => x.CreateUserId,
                        principalTable: "User",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                },
                comment: "项目用户表");

            migrationBuilder.CreateIndex(
                name: "IX_TrialIdentityUser_CreateUserId",
                table: "TrialIdentityUser",
                column: "CreateUserId");

            migrationBuilder.CreateIndex(
                name: "IX_TrialIdentityUser_IdentityUserId",
                table: "TrialIdentityUser",
                column: "IdentityUserId");

            migrationBuilder.CreateIndex(
                name: "IX_TrialIdentityUser_TrialId",
                table: "TrialIdentityUser",
                column: "TrialId");
        }

        /// <inheritdoc />
        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropTable(
                name: "TrialIdentityUser");

            migrationBuilder.AlterTable(
                name: "TrialUser",
                comment: "运维人员与项目关联关系表 - 实体",
                oldComment: "项目用户角色表");
        }
    }
}
