﻿using System;
using Microsoft.EntityFrameworkCore.Migrations;

#nullable disable

namespace IRaCIS.Core.Infra.EFCore.Migrations
{
    /// <inheritdoc />
    public partial class TrialSiteUserRoleModify : Migration
    {
        /// <inheritdoc />
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.AlterTable(
                name: "TrialSiteUser",
                comment: "项目 - 项目中心用户角色关系表",
                oldComment: "项目 - 项目中心用户关系表");

            migrationBuilder.AddColumn<Guid>(
                name: "TrialUserId",
                table: "TrialUser",
                type: "uniqueidentifier",
                nullable: false,
                defaultValue: new Guid("00000000-0000-0000-0000-000000000000"));

            migrationBuilder.CreateIndex(
                name: "IX_TrialUser_TrialUserId",
                table: "TrialUser",
                column: "TrialUserId");

            migrationBuilder.AddForeignKey(
                name: "FK_TrialUser_TrialIdentityUser_TrialUserId",
                table: "TrialUser",
                column: "TrialUserId",
                principalTable: "TrialIdentityUser",
                principalColumn: "Id",
                onDelete: ReferentialAction.Cascade);
        }

        /// <inheritdoc />
        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_TrialUser_TrialIdentityUser_TrialUserId",
                table: "TrialUser");

            migrationBuilder.DropIndex(
                name: "IX_TrialUser_TrialUserId",
                table: "TrialUser");

            migrationBuilder.DropColumn(
                name: "TrialUserId",
                table: "TrialUser");

            migrationBuilder.AlterTable(
                name: "TrialSiteUser",
                comment: "项目 - 项目中心用户关系表",
                oldComment: "项目 - 项目中心用户角色关系表");
        }
    }
}
