﻿using System;
using Microsoft.EntityFrameworkCore.Migrations;

#nullable disable

namespace IRaCIS.Core.Infra.EFCore.Migrations
{
    /// <inheritdoc />
    public partial class SignDoc : Migration
    {
        /// <inheritdoc />
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.CreateTable(
                name: "SystemDocConfirmedIdentityUser",
                columns: table => new
                {
                    Id = table.Column<Guid>(type: "uniqueidentifier", nullable: false),
                    SystemDocumentId = table.Column<Guid>(type: "uniqueidentifier", nullable: false),
                    ConfirmTime = table.Column<DateTime>(type: "datetime2", nullable: true),
                    ConfirmUserId = table.Column<Guid>(type: "uniqueidentifier", nullable: false),
                    SignFirstViewTime = table.Column<DateTime>(type: "datetime2", nullable: true),
                    SignText = table.Column<string>(type: "nvarchar(1000)", maxLength: 1000, nullable: false),
                    CreateUserId = table.Column<Guid>(type: "uniqueidentifier", nullable: false),
                    CreateTime = table.Column<DateTime>(type: "datetime2", nullable: false),
                    DeleteUserId = table.Column<Guid>(type: "uniqueidentifier", nullable: true),
                    IsDeleted = table.Column<bool>(type: "bit", nullable: false),
                    DeletedTime = table.Column<DateTime>(type: "datetime2", nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_SystemDocConfirmedIdentityUser", x => x.Id);
                    table.ForeignKey(
                        name: "FK_SystemDocConfirmedIdentityUser_IdentityUser_ConfirmUserId",
                        column: x => x.ConfirmUserId,
                        principalTable: "IdentityUser",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_SystemDocConfirmedIdentityUser_SystemDocument_SystemDocumentId",
                        column: x => x.SystemDocumentId,
                        principalTable: "SystemDocument",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_SystemDocConfirmedIdentityUser_User_CreateUserId",
                        column: x => x.CreateUserId,
                        principalTable: "User",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                },
                comment: "后台 - 系统文档签署记录");

            migrationBuilder.CreateTable(
                name: "TrialDocConfirmedIdentityUser",
                columns: table => new
                {
                    Id = table.Column<Guid>(type: "uniqueidentifier", nullable: false),
                    TrialDocumentId = table.Column<Guid>(type: "uniqueidentifier", nullable: false),
                    ConfirmTime = table.Column<DateTime>(type: "datetime2", nullable: true),
                    ConfirmUserId = table.Column<Guid>(type: "uniqueidentifier", nullable: false),
                    SignFirstViewTime = table.Column<DateTime>(type: "datetime2", nullable: true),
                    SignText = table.Column<string>(type: "nvarchar(1000)", maxLength: 1000, nullable: false),
                    CreateUserId = table.Column<Guid>(type: "uniqueidentifier", nullable: false),
                    CreateTime = table.Column<DateTime>(type: "datetime2", nullable: false),
                    DeleteUserId = table.Column<Guid>(type: "uniqueidentifier", nullable: true),
                    IsDeleted = table.Column<bool>(type: "bit", nullable: false),
                    DeletedTime = table.Column<DateTime>(type: "datetime2", nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_TrialDocConfirmedIdentityUser", x => x.Id);
                    table.ForeignKey(
                        name: "FK_TrialDocConfirmedIdentityUser_IdentityUser_ConfirmUserId",
                        column: x => x.ConfirmUserId,
                        principalTable: "IdentityUser",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_TrialDocConfirmedIdentityUser_TrialDocument_TrialDocumentId",
                        column: x => x.TrialDocumentId,
                        principalTable: "TrialDocument",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_TrialDocConfirmedIdentityUser_User_CreateUserId",
                        column: x => x.CreateUserId,
                        principalTable: "User",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateIndex(
                name: "IX_SystemDocConfirmedIdentityUser_ConfirmUserId",
                table: "SystemDocConfirmedIdentityUser",
                column: "ConfirmUserId");

            migrationBuilder.CreateIndex(
                name: "IX_SystemDocConfirmedIdentityUser_CreateUserId",
                table: "SystemDocConfirmedIdentityUser",
                column: "CreateUserId");

            migrationBuilder.CreateIndex(
                name: "IX_SystemDocConfirmedIdentityUser_SystemDocumentId",
                table: "SystemDocConfirmedIdentityUser",
                column: "SystemDocumentId");

            migrationBuilder.CreateIndex(
                name: "IX_TrialDocConfirmedIdentityUser_ConfirmUserId",
                table: "TrialDocConfirmedIdentityUser",
                column: "ConfirmUserId");

            migrationBuilder.CreateIndex(
                name: "IX_TrialDocConfirmedIdentityUser_CreateUserId",
                table: "TrialDocConfirmedIdentityUser",
                column: "CreateUserId");

            migrationBuilder.CreateIndex(
                name: "IX_TrialDocConfirmedIdentityUser_TrialDocumentId",
                table: "TrialDocConfirmedIdentityUser",
                column: "TrialDocumentId");
        }

        /// <inheritdoc />
        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropTable(
                name: "SystemDocConfirmedIdentityUser");

            migrationBuilder.DropTable(
                name: "TrialDocConfirmedIdentityUser");
        }
    }
}
